mod Ex06b logic: 'cl'

incl Mtex

incl Mtexg

incl Mauxb

loc rem 
  \para \bf  6. CVICENIE Z PREDMETU M-INAA-046 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.17 
  \para* \it  Datum:  \end stvrtok 29.3.2007 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/M-INAA-046-svp/0607ls/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane celociselnej 
  odmocnine a dyadickej aritmetike. 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Recursion on Notation.  \end 

rem 
  \para \bf  Subsection. Dyadic Arithmetic.  \end 

rem 
  \para \bf  [CL] Dyadic successors.  \end 
  \eq* 
    S1(x) = 2*x+1
  \end
  \eq* 
    S2(x) = 2*x+2
  \end
  \para The functions are defined in the module \ft Standard \end. 

rem 
  \para \bf  Dyadic case analysis.  \end Show that the principle of dyadic case 
  analysis is admissible in Peano arithmetic. 
  \para \it  Remark.  \end Prove the following claim justifying the completeness 
  condition of the principle: 
  \eq* 
    x = 0 \/ \e y x = S1(y) \/ \e y x = S2(y)
  \end
  \para \it  Hint.  \end See the theorem \ft Quotient_remainder2 \end in the 
  module \it  Maux*  \end. 

thm Dyadic_case_analysis
  x = 0 \/ \e y x = S1(y) \/ \e y x = S2(y)

rem 
  \para \bf  [CL] Dyadic case analysis.  \end Syntax: 
  \eq* 
    'case N2 ; <term>'
  \end
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_case Tex_f2_g_x_sc(N2,Tex0_tau) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f0_g_x_nothing,
                            Tex_f2_g_x_branch(Tex_f1_g_x_assum Tex_f2_g_eq(Tex0_tau,
                                                                           0),
                                              Tex_f2_g_x_branch(Tex_f1_g_x_assum Tex_f2_g_eq(Tex0_tau,
                                                                                             S1(x)),
                                                                Tex_f1_g_x_assum Tex_f2_g_eq(Tex0_tau,
                                                                                             S2(x)))),
                            Tex_f0_g_x_nothing)
         \end
         \para where \ft x \end is a new variable \it  (eigen-variable)  \end. 
  \end
  \para The predicate \ft N2 \end is defined in the module \ft Standard \end. 

rem 
  \para \bf  Dyadic induction.  \end Show that the principle of dyadic induction 
  is admissible in Peano arithmetic. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 
  \para \it  Hint.  \end Reduce dyadic induction to complete induction. 

theory Dyadic_induction

pred A 'Tex_p1_phi_subst'

axiom Base_case
  A(0)

axiom Induction_step1
  A(x) -> A S1(x)

axiom Induction_step2
  A(x) -> A S2(x)

thm Conclusion
  A(x)

end theory Dyadic_induction

rem 
  \para \bf  [CL] Dyadic induction.  \end Syntax: 
  \eq* 
    'ind N2 ; <variable> ; [<variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(N2,x) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f0_g_x_nothing,
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,
                                                                          0),
                                              Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f2_g_imp(Tex2_bappl1(Tex0_phi,
                                                                                                         x),
                                                                                             Tex2_bappl1(Tex0_phi,
                                                                                                         S1(x))),
                                                                Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f2_g_imp(Tex2_bappl1(Tex0_phi,
                                                                                                                           x),
                                                                                                               Tex2_bappl1(Tex0_phi,
                                                                                                                           S2(x))),
                                                                                  Tex_f1_g_x_assum Tex2_bappl1(Tex0_phi,
                                                                                                               x)))),
                            Tex_f0_g_x_nothing)
         \end
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(Tex_f2_g_x_sc(N2,x),y,z) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f0_g_x_nothing,
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex2_bappl1(Tex0_phi,
                                                                          0),
                                              Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_forall(y,
                                                                                                             Tex_f2_g_forall(z,
                                                                                                                             Tex2_bappl1(Tex0_phi,
                                                                                                                                         x))),
                                                                                             Tex2_bappl1(Tex0_phi,
                                                                                                         S1(x))),
                                                                Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_forall(y,
                                                                                                                               Tex_f2_g_forall(z,
                                                                                                                                               Tex2_bappl1(Tex0_phi,
                                                                                                                                                           x))),
                                                                                                               Tex2_bappl1(Tex0_phi,
                                                                                                                           S2(x))),
                                                                                  Tex_f1_g_x_assum Tex2_bappl1(Tex0_phi,
                                                                                                               x)))),
                            Tex_f0_g_x_nothing)
         \end
  \end

rem 
  \para \bf  Dyadic size.  \end 

fun Dsz 'Tex_f1_n2_sz'
  Dsz(0) = 0
  Dsz S1(x) = Dsz(x)+1
  Dsz S2(x) = Dsz(x)+1

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Dsz(x) = 0 <-> x = 0
  \end
  \eq* 
    Dsz(x) = 1 <-> x = 1 \/ x = 2
  \end
  \para \it  Hint.  \end Prove the claims by dyadic case analysis. 

thm Dsz_is_zero
  Dsz(x) = 0 <-> x = 0

thm Dsz_is_one
  Dsz(x) = 1 <-> x = 1 \/ x = 2

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Dsz(x) = n <-> Exp(2,n) <= x+1 & x+1 < Exp(2,n+1)
  \end
  \para \it  Hint.  \end Prove the claim by induction on \ft n \end with dyadic 
  case analysis in the induction step. 

thm Dsz_exp
  Dsz(x) = n <-> Exp(2,n) <= x+1 & x+1 < Exp(2,n+1)

rem 
  \para \bf  Dyadic concatenation.  \end 

fun/2 Dconc 'Tex_f2_n2_conc'
  Dconc(x,0) = x
  Dconc(x,S1(y)) = S1 Dconc(x,y)
  Dconc(x,S2(y)) = S2 Dconc(x,y)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Dconc(x,y) = x*Exp(2,Dsz(y))+y
  \end

thm Dconc_expl
  Dconc(x,y) = x*Exp(2,Dsz(y))+y

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Dconc(x,y) = 0 <-> x = 0 & y = 0
  \end
  \eq* 
    Dconc(0,y) = y
  \end
  \eq* 
    Dconc(Dconc(x,y),z) = Dconc(x,Dconc(y,z))
  \end
  \eq* 
    Dsz Dconc(x,y) = Dsz(x)+Dsz(y)
  \end

thm Dconc_is_zero
  Dconc(x,y) = 0 <-> x = 0 & y = 0

thm Dconc_left_zero
  Dconc(0,y) = y

thm Dconc_assoc
  Dconc(Dconc(x,y),z) = Dconc(x,Dconc(y,z))

thm Dconc_szd
  Dsz Dconc(x,y) = Dsz(x)+Dsz(y)

rem 
  \para \bf  Dyadic reversal.  \end 

fun Drev 'Tex_f1_n2_rev'
  Drev(0) = 0
  Drev S1(x) = Dconc(1,Drev(x))
  Drev S2(x) = Dconc(2,Drev(x))

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Drev(x) = 0 <-> x = 0
  \end
  \eq* 
    Drev Dconc(x,y) = Dconc(Drev(y),Drev(x))
  \end
  \eq* 
    Drev Drev(x) = x
  \end
  \eq* 
    \e y Drev(y) = x
  \end
  \eq* 
    Drev(x) = Drev(y) -> x = y
  \end
  \eq* 
    Dsz Drev(x) = Dsz(x)
  \end

thm Drev_is_zero
  Drev(x) = 0 <-> x = 0

thm Drev_dconc
  Drev Dconc(x,y) = Dconc(Drev(y),Drev(x))

thm Drev_drev
  Drev Drev(x) = x

thm Drev_surjective
  \e y Drev(y) = x

thm Drev_injective
  Drev(x) = Drev(y) -> x = y

thm Drev_szd
  Dsz Drev(x) = Dsz(x)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Dconc(y,x) = Dconc(z,x) -> y = z
  \end
  \eq* 
    Dconc(x,y) = Dconc(x,z) -> y = z
  \end

thm Dconc_cancel_right
  Dconc(y,x) = Dconc(z,x) -> y = z

thm Dconc_cancel_left
  Dconc(x,y) = Dconc(x,z) -> y = z

