mod Mauxb logic: 'cl'

incl Mtex

rem 
  \para \bf  Quotient and remainder for divisor 2.  \end 

lemma Quotient_remainder
  y != 0 -> \e q\e r(x = q*y+r & r < y)
proof 
 indm x @ x1
  case Dich; y,x @ x1,y1; x1,y1
   inst \a x1(x1 < x -> \e r(\e q x1 = y*q+r & r < y)).0; x-y
    eigen \e r(\e q x = y+y*q+r & r < y).0:0,3,0,1,0; r,q
     inst* \e r1(\e q1 q*y+r+y = y*q1+r1 & r1 < y):0,3,0,1,0; r; q+1 proved...
   inst* \e r(\e q x = y*q+r & r < y):0,3,0,1,0; x; 0 proved....

thm Quotient_remainder2
  \e q\e r(x = 2*q+r & r < 2)
proof 
 use Quotient_remainder.0; 2; x proved..

rem 
  \para \bf  Exponentiation.  \end 

fun/2 Exp 'Tex_f2_n_exp'
  Exp(x,0) = 1
  Exp(x,y+1) = x*Exp(x,y)

thm Exp_is_zero
  Exp(x,y) = 0 <-> x = 0 & y != 0
proof 
 ind N; y @ 0; y
  proved
  weak Exp(x,y) = 0 <-> x = 0 & y != 0
   cut x = 0
    proved
    proved....

thm Exp_is_one
  Exp(x,y) = 1 <-> x = 1 \/ y = 0
proof 
 ind N; y @ 0; y
  proved
  split* x = 1 & (x = 1 \/ y = 0) <-> x = 1.2,0,0
   proved
   proved...

thm Exp_plus
  Exp(x,y+z) = Exp(x,y)*Exp(x,z)
proof 
 ind N; y @ 0; y
  proved
  proved..

thm Exp_minus
  x != 0 & y >= z -> Exp(x,y-z) = Exp(x,y)/Exp(x,z)
proof 
 ind N; y; z @ 0; y
  proved
  case N; z @ 0; z1
   proved
   inst \a z(y >= z -> Exp(x,y-z) = Exp(x,y)/Exp(x,z)); z1 proved....

thm Exp_cancel_eq
  x > 1 -> Exp(x,y) = Exp(x,z) <-> y = z
proof 
 ind N; y; z @ 0; y
  use Exp_is_one.0; x; z proved.
  case N; z @ 0; z1
   proved
   inst \a z(Exp(x,y) = Exp(x,z) <-> y = z).0; z1 proved....

thm Exp_cancel_le
  x > 1 -> Exp(x,y) <= Exp(x,z) <-> y <= z
proof 
 ind N; y; z @ 0; y
  use Exp_is_zero.0; x; z proved.
  case N; z @ 0; z1
   use Exp_is_zero.0; x; y proved.
   inst \a z(Exp(x,y) <= Exp(x,z) <-> y <= z).0; z1 proved....

thm Exp_cancel_lt
  x > 1 -> Exp(x,y) < Exp(x,z) <-> y < z
proof 
 ind N; y; z @ 0; y
  cut z = 0
   proved
   use Exp_is_zero.0; x; z-1 proved..
  case N; z @ 0; z1
   use Exp_is_zero.0; x; y proved.
   inst \a z(Exp(x,y) < Exp(x,z) <-> y < z).0; z1 proved....

